import { SteckbriefInterface, teammembers } from "../components/data/steckbriefe";
import { H2 } from "../components/Headings";
import { LoremMedium } from "../components/Loremipsum";
import { useNavigateTabs } from "../utils/navigation";

export function Team() {
  useNavigateTabs();
  let teambriefe = createSteckbriefe(teammembers); 
  return (
    <>
      <br/>

      <br/>
      <H2 text="Members" id="members"/>
      {teambriefe}



      <H2 text="Instructor" id="instructor"/>
      <div className="row center">
      <div className="col">
         </div>
         <div className="col">
        <Steckbrief url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
          name="Sinan Zimmermann"
          job="Job"
          > 
            . 
          </Steckbrief>
        
        </div>
         <div className="col">
         
         </div>
      </div>
      
      <H2 text="Advisors" id="Advisors"/>
      <div className="row center">
        <div className="col">
          <Steckbrief 
          url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
          name="Felicitas Zimmer"
          job="Job"
          > 
            . 
          </Steckbrief>
        </div>
        <div className="col">
         
        </div>
        <div className="col">
        <Steckbrief url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
          name="Lucas Krause"
          job="Job"
          > 
            . 
          </Steckbrief>
        
        </div>
      </div>
      <H2 text="Principal Investigators" id="PIS"/>
      <div className="row center">
        <div className="col">
          <Steckbrief 
          url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
          name="Jörn Kalinowski"
          job="Job"
          > 
            . 
          </Steckbrief>
        </div>
        <div className="col"></div>
        <div className="col">
        <Steckbrief url="https://static.igem.wiki/teams/5247/placeholders/placehilderperson.jpeg"
          name="Kristian Müller"
          job="Job"
          > 
            . 
          </Steckbrief>
        
        </div>
      </div>
    </>
  );
}


interface SteckProps{
  name?: string; 
  url: string; 
  children: React.ReactNode; 
  job: string,

}

function createSteckbriefe(data: Array<SteckbriefInterface>){
  let briefe = []
  for (let index = 0; index < data.length; index++) {
    let thename = "" + data[index].vorname + data[index].nachname; 
    // Conditional head of
    var headof = <></>; 
    if(data[index].headof){
      var headof = <><div className="">Head of: {data[index].headof} </div> <br/></>; 
    }
    // Jobs
    var jobs = ""; 
    for (let i = 0; i < data[index].igemjob.length; i++) {
        if (i + 1 === data[index].igemjob.length ) {
          jobs += " and " + data[index].igemjob[i];
        }
        else if (i  ===  0 ) {
          jobs +=  data[index].igemjob[i];
        }
        else{
          jobs +=  data[index].igemjob[i] + ", ";
        }
    }
    // Funfacts 
    var funfacts = [];
    for (let i = 0; i < data[index].funfacts.length; i++) {
      funfacts.push(<li> {data[index].funfacts[i]} </li>); 
    }
    // Hobbies
    var hobbs = ""; 
    for (let i = 0; i < data[index].hobbies.length; i++) {
      if (i + 1 === data[index].igemjob.length ) {
        hobbs += " and " + data[index].hobbies[i];
      }
      else if (i  ===  0 ) {
        hobbs +=  data[index].hobbies[i];
      }
      else{
        hobbs +=  data[index].hobbies[i] + ", ";
      }
  }
    let frontbriefclass = "frontbrief frontbrief"+thename; 
    let backbriefclass = "backbrief backbrief"+thename;

    let picture = <div className="col-2 lnp center"><img src={data[index].zweitfoto} style={{display: "none"}} className={"img team-img "+backbriefclass}/><img src={data[index].hauptfoto} className={"img team-img "+frontbriefclass}></img></div> 
    let namerow = <div className="row"><div className="team-name"> {data[index].title} {data[index].vorname} {data[index].nachname} <span className="pronouns"> {data[index].pronouns} </span> </div>  <div className="col"> <a href={data[index].linkedinurl}> <img className="team-socials" src="https://static.igem.wiki/teams/5247/design/icons/linkedin.png" /> </a></div> </div>; 
    let frontparagraph = <div className={"row " + frontbriefclass}> <p>"As an international student, iGEM offers me a unique opportunity to not only expand and deepen my scientific experience by working with a research team but also to enhance my social communication skills within my scientific field",</p> </div> ; 
    let facts = <div className={frontbriefclass}><div className="">Age: {data[index].age} </div> <br/> {headof} <div>Part of: {jobs}</div> <br/> <div className=""> Major: {data[index].studiengang} </div> <br/> <div className=""> Scientific interests: {data[index].scientificinterests} </div> </div>; 
    let backbutton =  <div className={backbriefclass} style={{display: "none"}}>   <div className="parent-button"><button onClick={flipBack(thename)} className="frontbutton">Click me</button></div></div>
    let funfactlist = <div className={backbriefclass} style={{display: "none"}}><b>Funfacts: </b><ul> {funfacts}</ul></div>
    let favmusic = <><h6>Favourite music:</h6><p>{data[index].favmusic}</p></>
    let hobbielist = <><h6>Hobbies:</h6> <p> {hobbs} </p></>
    let backparagraph = <div className={"row "+backbriefclass} style={{display: "none"}}>{favmusic}{hobbielist}</div> 
    let paragraphs = <div className="steckbody"> {frontparagraph} {backparagraph} </div>
    let frontbutton =  <div className={frontbriefclass}> <div className="parent-button"><button onClick={flip(thename)} className="frontbutton">Click me</button></div></div>
    
    let hole = 
            <div> 
              <div className="row steckbrief"> {picture}  
                <div className="col-5"> 
                  <div className="row"> {namerow}
                  <hr/>  
                  </div>   
                  {paragraphs}     
                </div> 
                <div className="col-4 brieffacts">
                  <br/><br/>  {funfactlist} {facts} 
                </div>                   
                </div> <div className="row" style={{marginTop: "1rem", marginBottom: "1rem"}}> <div className="col-2"> {frontbutton} {backbutton}</div>  <div className="col"><details className={frontbriefclass} ><summary> <b>Personal motivation and challenges</b> </summary><div> <LoremMedium/></div></details></div>                                                                                                                                                        </div> 
            </div>
    let whole = <div className={"steckbrief-box"} id={thename}> {hole} </div>; 
    briefe.push(whole); 
  }
  return briefe; 
}



function Steckbrief({children, url, name,job }: SteckProps){ 
  let thename = "" + name; 
  return(
    <div className={"steckbrief-box"} id={thename}>
    
    {/* front */}
    {/* back */}
      
    </div>
  )
}

function flip(element: string){
  const flipp = (_event: React.MouseEvent<HTMLElement, MouseEvent>) => {
    let elementsToHide = document.getElementsByClassName("frontbrief"+element);
      for (let i = 0; i < elementsToHide.length; i++) {
        (elementsToHide[i] as HTMLElement).style.display = "none";
      }
    let elementsToFind = document.getElementsByClassName("backbrief"+element);
    for (let i = 0; i < elementsToFind.length; i++) {
      (elementsToFind[i] as HTMLElement).style.display = "block";
    }
  }
  return flipp; 
}

function flipBack(element: string){
  const flippback = (_event: React.MouseEvent<HTMLElement, MouseEvent>) => {
    let elementsToHide = document.getElementsByClassName("backbrief"+element);
      for (let i = 0; i < elementsToHide.length; i++) {
        (elementsToHide[i] as HTMLElement).style.display = "none";
      }
    let elementsToFind = document.getElementsByClassName("frontbrief"+element);
    for (let i = 0; i < elementsToFind.length; i++) {
      (elementsToFind[i] as HTMLElement).style.display = "block";
    }
  }
  return flippback;  
}